(function () {
    window.onload = function () {
        var elementHeader = document.getElementById('header1');
        var textAppName = elementHeader.textContent;

        var language = 'en';
        var textHelp = 'Help';
        var textToc = 'Table of Contents';
        if (/ja\/index\.html/.test(location.href)) {
            language = 'ja';
            textHelp = 'ヘルプ';
            textToc = '目次';
        }

        var metas = document.head.getElementsByTagName('meta');
        for (let i = 0; i < metas.length; i++) {
            var meta = metas[i];
            if (meta.httpEquiv === 'Content-Language') {
                meta.content = language;
            }
        }
        document.title = textAppName + ' ' + textHelp;
        elementHeader.textContent = document.title;
        document.getElementById('toc-head').textContent = textToc;

        var main = document.getElementById('main');
        var elementToc = document.createElement('ul');
        var elementLargeSection;
        for (var i = 0; i < main.childNodes.length; i++) {
            var node = main.childNodes[i];
            if (!node.tagName) {
                continue;
            }
            var tagName = node.tagName.toUpperCase();
            if (tagName === 'H2') {
                if (elementLargeSection && elementLargeSection.childNodes.length > 0) {
                    elementToc.appendChild(elementLargeSection);
                }
                elementLargeSection = document.createElement('ul');

                elementToc.appendChild(generateListElement(node));
            } else if (tagName === 'H3') {
                if (elementLargeSection) {
                    elementLargeSection.appendChild(generateListElement(node));
                }
            }
        }
        if (elementLargeSection && elementLargeSection.childNodes.length > 0) {
            elementToc.appendChild(elementLargeSection);
        }
        document.getElementById('toc').appendChild(elementToc);

        function generateListElement(node) {
            var elementList = document.createElement('li');
            var elementAnchor = document.createElement('a');
            elementAnchor.textContent = node.textContent;
            elementAnchor.href = '#' + node.id;
            elementList.appendChild(elementAnchor);
            return elementList;
        }
    }
})();